#!/usr/bin/perl

# (c) INRIA-IMEDIA 2008. This program was created for TrecVid2008
use strict;

die "arguments:  refGroup nonRefGroup movieDuration minLengthRef,maxLengthRef minLengthNonRef,maxLengthNonRef beginAndEndRejectedMaterialAmount beginAndEndNonRefPresentMaterialAmount numRequests" if $#ARGV!=7;

my %durations = read_duration_map($ARGV[2]);
my @ref_group = read_group($ARGV[0]);
my @non_ref_group = read_group($ARGV[1]);

my @ref_range = split(/,/, $ARGV[3]);
my @non_ref_range = split(/,/, $ARGV[4]);
my $border_src = int($ARGV[5]);
my $border_dst = int($ARGV[6]);
my $num_requests = int($ARGV[7]);

srand(time);
my $count=0;
my $type=-1;
for(my $request=0; $request<$num_requests; $request++)
{
	my $offset_ref;
	my $offset_non_ref;
	my $offset;
	my $length_ref;
	my $length_non_ref; 
	my $random_ref;
	my $random_non_ref;
	my %movie_ref;
	my %movie_non_ref;
	
	if( $count!=1000 )
	{
		$type = int(rand(3));
	}

	do
	{
		$random_ref = int(rand($#ref_group+1));
		$random_non_ref = int(rand($#non_ref_group+1));
		
		%movie_ref = %{$durations{file_name($ref_group[$random_ref])}};
		%movie_non_ref = %{$durations{file_name($non_ref_group[$random_non_ref])}};
	}
	while(1==$type && ($movie_ref{"duration"}{"fps"}!=$movie_non_ref{"duration"}{"fps"} || $movie_ref{"size"}!=$movie_non_ref{"size"}) );
    
    
	if( 0==$type )
	{
		my $fps = $movie_ref{"duration"}{"fps"};
		
		for($count=0; $count<1000; $count++)
		{
			$offset_ref = int(rand()*($movie_ref{"duration"}{"n"}-2*$fps*$border_src) + $fps*$border_src);
            next if $offset_ref<0;
            
			$length_ref = rand()*($ref_range[1]-$ref_range[0])+$ref_range[0];
            die if $length_ref<0;
			$length_ref *= $fps;
			
			last if( $offset_ref+$length_ref < $movie_ref{"duration"}{"n"}-$fps*$border_src );
		}
        
		if( 1000==$count )
		{
			$request--;
		}
		else
		{
			printf	$request . " " . ($type+1) . " null 0:0:0 0:0:0 " . $ref_group[$random_ref] . " ";
			printf	frame_number_2_tc($offset_ref, $fps);
			print	" ";
			printf	frame_number_2_tc($offset_ref+$length_ref, $fps);
			printf	"  0:0:0\n";
		}
	}
	elsif( 1==$type )
	{
		my $fps = $movie_ref{"duration"}{"fps"};
		
		for($count=0; $count<1000; $count++)
		{
			$length_ref = rand()*($ref_range[1]-$ref_range[0])+$ref_range[0];
            die if $length_ref<0;
			$length_ref *= $fps;
            
			$length_non_ref = rand()*($non_ref_range[1]-$non_ref_range[0])+$non_ref_range[0];
            die if $length_non_ref<0;
            $length_non_ref *= $fps;
            
			next if( $length_ref+2*$fps*$border_dst > $length_non_ref );
			
			$offset = int(rand()*($length_non_ref - $length_ref-2*$fps*$border_dst) + $fps*$border_dst);
            next if $offset<0;
			
			$offset_ref = int(rand()*($movie_ref{"duration"}{"n"}-2*$fps*$border_src) + $fps*$border_src);
            next if $offset_ref<0;
            
			$offset_non_ref = int(rand()*($movie_non_ref{"duration"}{"n"}-2*$fps*$border_src) + $fps*$border_src);
			next if $offset_non_ref<0;
            
			next if( $offset_ref+$length_ref > $movie_ref{"duration"}{"n"}-$fps*$border_src  );
			next if( $offset_non_ref+$length_non_ref > $movie_non_ref{"duration"}{"n"}-$fps*$border_src  );
			
			last;
		}
		
		if( 1000==$count )
		{
			$request--;
		}
		else
		{
			
			printf $request . " " .  ($type+1) . " ";
			
			printf $non_ref_group[$random_non_ref] . " ";
			printf frame_number_2_tc($offset_non_ref, $fps) . " ";
			printf frame_number_2_tc($offset_non_ref+$length_non_ref, $fps) . " "; 
			
			printf $ref_group[$random_ref] . " ";
			printf frame_number_2_tc($offset_ref, $fps) . " "; 
			printf frame_number_2_tc($offset_ref+$length_ref, $fps) . " "; 
			printf frame_number_2_tc($offset, $fps); 
			
			printf("\n");
		}
		
	}
	elsif( 2==$type )
	{
		my $fps = $movie_non_ref{"duration"}{"fps"};

		for($count=0; $count<1000; $count++)
		{
			$offset_non_ref = int(rand()*($movie_non_ref{"duration"}{"n"}-2*$fps*$border_src) + $fps*$border_src);
            next if $offset_non_ref<0;
            
			$length_non_ref = rand()*($non_ref_range[1]-$non_ref_range[0])+$non_ref_range[0];
            die if $length_non_ref<0;
			$length_non_ref *= $fps;
			
			last if( $offset_non_ref+$length_non_ref < $movie_non_ref{"duration"}{"n"}-$fps*$border_src )
		}
		if( 1000==$count )
		{
			$request--;
		}
		else
		{
			printf $request . " ".  ($type+1) . " " . $non_ref_group[$random_non_ref] . " ";
			printf frame_number_2_tc($offset_non_ref, $fps) . " "; 
			printf frame_number_2_tc($offset_non_ref+$length_non_ref, $fps) . " "; 
			printf "null 0:0:0 0:0:0 0:0:0\n";
		}
	}
    else
    {
        die "type $type unrecognized\n";
    }
}

sub read_duration
{
	my $filename = shift;
	open FILE, $filename;
	
	my @list;
	while(<FILE>)
	{
        my $l = $_;
		$l =~ s/\n$//;
		$l =~ s/\r$//;
        my @els = split(/ |\t/, $l);
		
        my %line;
        $line{"name"} = $els[0];
        $line{"duration"} = {tc_decode($els[1])};
        $line{"size"} = $els[2];
		
		push @list, {%line};
	}
	close FILE;
	
	return @list;
}

sub read_duration_map
{
	my $filename = shift;
	open FILE, $filename;
	
	my %list;
	while(<FILE>)
	{
        my $l = $_;
        $l =~ s/\n$//;
        $l =~ s/\r$//;
        my @els = split(/\s+/, $l);
        #printf $l . "\n";
		
        my $movie_name = file_name($els[0]);
        
        my %line;
        $line{"name"} = $els[0];
        $line{"duration"} = {tc_decode($els[1])};
        $line{"size"} = $els[2];
        
#        printf "name: " . $line{"name"} . " duration: " . $line{"duration"}{"n"} . " size: " . $line{"size"} . "\n";
        $list{$movie_name} = {%line};
	}
	close FILE;
	
	return %list;
}

sub tc_decode
{
    my $tc = shift;
    my @els = split(/:|\//, $tc);
	my $h = int($els[0]);
	my $m = int($els[1]);
	my $s = int($els[2]);
	my $f = int($els[3]);
	my $fps = 1.0*$els[4];
    my $n = (($h*60+$m)*60+$s)*$fps+$f;
    
	my %tc_hash = {};
	
	$tc_hash{"h"}   = $h;
	$tc_hash{"m"}   = $m;
	$tc_hash{"s"}   = $s;
	$tc_hash{"f"}   = $f;
	$tc_hash{"fps"} = $fps;
	$tc_hash{"n"}   = $n;
#	printf "tc_decode $h $m $s $f $fps $n\n";
    
	return %tc_hash;
}

sub read_group
{
	my $filename = shift;
	open FILE, $filename;
	
	my @list;
	while(<FILE>)
	{   
		my $l = $_;
		$l =~ s/\n$//;
		$l =~ s/\r$//;
		
		my @els = split(/\s+/, $l);
		
		push @list, @els;
	}
	close FILE;
	
	return @list;
}

sub frame_number_2_tc
{
    my $n = shift;
	my $fps = shift;
    
	$n = int($n);
    my $s = int($n/$fps);
    $n -= int($s*$fps);
    my $m = int($s/60);
    $s -= int($m*60);
    my $h = int($m/60);
    $m -= int($h*60);
    
    return $h . ":" . $m . ":" . $s . ":" . $n . "/$fps";    
}

sub file_name
{
	my $f = shift;
	my @els = split(/\//, $f);
	
	return $els[$#els];
}
