/*
 *  movieDuration.c
 *  dev
 *
 *  Created by laurent joyeux on 31/03/08.
 *  Copyright 2008 Laurent Joyeux. All rights reserved.
 *
 */


#include <VideoLib/VideoLib.h>
#include <stdio.h>
#include <stdlib.h>


int main(int argc, char *argv[])
{
    ImageSequenceReader_t   *pisr;
    int                     i;
    TimeCode_t              tc;
	uint16_t				width, height;
	
    if( 1 == argc )
    {
        fprintf(stderr, "%s movie1 movie2 ...\n", argv[0]);
        fprintf(stderr, "(c) INRIA-IMEDIA 2008. This program was created for TrecVid2008\n");
        
        return -1;
    }
    
    fprintf(stderr, "(c) INRIA-IMEDIA 2008. This program was created for TrecVid2008\n");
    
    
    for(i=1; i<argc; i++)
    {
        pisr = isrOpen( argv[i] );
        if( NULL == pisr )
        {
            fprintf( stderr, "cannot open movie\n");
            continue;
        }
        int numOfFrames = isrGetNumberOfFrames( pisr );

        tc.fps = isrGetFPS( pisr );
        tcFrameToTC(&tc, numOfFrames);
        
		isrGetSize(pisr, &width, &height);
		
        printf("%s %d:%d:%d:%d/%.3lf %dx%d\n", argv[i], (int) tc.hour, (int) tc.min, (int) tc.sec, (int) tc.subSec, (double) tc.fps, (int) width, (int) height );
        
        isrClose( pisr );
    }

    return 0;
}
